import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.lang.*;
import java.awt.image.*;




public class texture extends Applet implements Runnable {
    Thread renderer = null;

    int[] pixels;
    int width, height;
    Image buffer = null;
    
    int[] texture;
    int texwidth, texheight;

    int[] logo;
    int logowidth, logoheight;
    
    // -----------------------------------------------
    // init java
    // -----------------------------------------------
    public void init() {
    }
    
    // --------------------------------------------
    // start -- start of applet --> start new thread
    // --------------------------------------------
    public void start() {
	if (renderer == null) {
	    renderer = new Thread(this);
	    renderer.start();
	}
    }
    
    public void TextureScreen( int Ax, int Ay, int Bx, int By, int Cx, int Cy ) {
	// compute deltas
	int dxdx = (Bx-Ax)/320,
	    dydx = (By-Ay)/320,
	    dxdy = (Cx-Ax)/200,
	    dydy = (Cy-Ay)/200;
	long offs = 0;
	// loop for all lines
	for (int j=0; j<200; j++)
	    {
		Cx = Ax;
		Cy = Ay;
		// for each pixel
		for (int i=0; i<320; i++)
		    {
			// get texel and store pixel
			pixels[(int)offs] = texture[((Cy>>8)&0xff00)+((Cx>>16)&0xff)];
			// interpolate to get next texel in texture space
			Cx += dxdx;
			Cy += dydx;
			offs++;
		    }
		// interpolate to get start of next line in texture space
		Ax += dxdy;
		Ay += dydy;
	    }
    }

    
    /*
     * render a textured screen in 8x8 blocks
     */
    public void BlockTextureScreen( int Ax, int Ay, int Bx, int By, int Cx, int Cy ) {
	// compute global deltas, 40 blocks along X, 25 blocks along Y
	int dxdx = (Bx-Ax)/40,
	    dydx = (By-Ay)/40,
	    dxdy = (Cx-Ax)/25,
	    dydy = (Cy-Ay)/25;
	// compute internal block deltas
	int dxbdx = (Bx-Ax)/320,
	    dybdx = (By-Ay)/320,
	    dxbdy = (Cx-Ax)/200,
	    dybdy = (Cy-Ay)/200;
	int baseoffs = 0, offs;
	// for all blocks along Y
	for (int j=0; j<25; j++) {
	    Cx = Ax;
	    Cy = Ay;
	    
	    // for all blocks along X
	    for (int i=0; i<40; i++) {
		offs = baseoffs;
		// set original position
		int Ex = Cx,
		    Ey = Cy;

		// for each line of 8 pixels in the block
		for (int y=0; y<8; y++) {
			
		    // set original position
		    int Fx = Ex,
			Fy = Ey;

		    // for each pixel in the block
		    for (int x=0; x<8; x++) {
			// get texel and store pixel
			pixels[offs] = texture[((Fy>>8)&0xff00)+((Fx>>16)&0xff)];
			// interpolate to find next texel
			Fx += dxbdx;
			Fy += dybdx;
			offs++;
		    }
		    // next line in the block
		    Ex += dxbdy;
		    Ey += dybdy;
		    offs += 312;
		}
		
		// next block
		baseoffs += 8;
		Cx += dxdx;
		Cy += dydx;
	    }
	    
	    // next line of blocks
	    baseoffs += 320*7;
	    Ax += dxdy;
	    Ay += dydy;
	}
    }

    public void DoRotoZoom( double cx, double cy, double radius, double angle ) {
	int x1 = (int)( 65536.0f * (cx + radius * Math.cos( (float)angle )) ),
	    y1 = (int)( 65536.0f * (cy + radius * Math.sin( (float)angle )) ),
	    x2 = (int)( 65536.0f * (cx + radius * Math.cos( (float)angle + 2.02458 )) ),
	    y2 = (int)( 65536.0f * (cy + radius * Math.sin( (float)angle + 2.02458 )) ),
	    x3 = (int)( 65536.0f * (cx + radius * Math.cos( (float)angle - 1.11701 )) ),
	    y3 = (int)( 65536.0f * (cy + radius * Math.sin( (float)angle - 1.11701 )) );
	BlockTextureScreen( x1, y1, x2, y2, x3, y3 );
	//TextureScreen( x1, y1, x2, y2, x3, y3 );
    }


    // -----------------------------------------------
    // run -- run method of thread
    // -----------------------------------------------
    public void run()
    {
	ColorModel colmodel = ColorModel.getRGBdefault();
	
	width = getWidth();
	height = getHeight();

	pixels = new int[width*height];
	MemoryImageSource mis = new MemoryImageSource(width, height, colmodel, pixels, 0, width);
	buffer = createImage(mis);
	if (buffer == null)	System.err.print("Ihh kan ikke oprette bufferen");

	java.awt.Image image = getImage(getDocumentBase(), "wallpaper.jpg");
        MediaTracker tracker = new MediaTracker(this);
        
        tracker.addImage( image, 0 );

	try { tracker.waitForID(0); } 
	catch (InterruptedException e) {}

	texheight = image.getHeight(null);
	texwidth = image.getWidth(null);
	texture = new int[texheight*texwidth];

        // create image grabber
        PixelGrabber pg = new PixelGrabber(image,0,0,texwidth,texheight,texture,0,texwidth);
        
        try { pg.grabPixels(); } 
        catch (InterruptedException e) { throw new Error("Ihh vi kan ikke loade billedet"); }

	
	System.err.print("Saa koerer vi\n");
	long currentTime=0;
	double timer=0.0;
        while (true) {

	    //currentTime=(long)timer;
	    DoRotoZoom( (float)2048 * Math.sin((float)currentTime/21547814.0f), 
			(float)2048 * Math.cos((float)currentTime/18158347.0f), 
			(float)256.0f+192.0f*Math.cos((float)currentTime/4210470.0f), 
			(float)(currentTime)/731287.0f );
	    //DoRotoZoom( 0, 0, 10, 0 ); 
	    /*
	    int off=0;
	    for (int x=0;x<320;x++) {
		for (int y=0;y<200;y++) {
		    pixels[off] = texture[off];
		    off++;
		}
	    }
	    */

	    buffer.flush();
	    repaint();
	    
	    try { Thread.sleep(20); } 
	    catch (InterruptedException e) {}
	    currentTime+=2;
	    //timer+=0.2;
	    //System.err.printf("hmm %d\n", currentTime);

	}
    }
    
    // --------------------------------------------
    // update -- render to screen
    // --------------------------------------------
    public void update(Graphics g)
    {
	paint(g);
    }


    // --------------------------------------------
    // paint -- only called while loading.
    // --------------------------------------------
    public void paint(Graphics gx)
    {
	if (buffer != null) gx.drawImage(buffer, 0,0, this);
    }

	 
    // --------------------------------------------
    // imageupdate -- force an update :)
    // --------------------------------------------
    public boolean imageUpdate(Image image, int i1, int j1, int k, int i2, int j2)
    {
	return true;
    }
}